function _abinit (e) {
	var d = document.getElementById('groups');
	var t = d.getElementsByTagName('table')[0];
	var trs = t.getElementsByTagName('tr');
	for (var i=0; i < trs.length; i++) {
		trs[i].addEventListener('click', _abgroupclick, false);
	}
	
	d = document.getElementById('people');
	t = d.getElementsByTagName('table')[0];
	var trs = t.getElementsByTagName('tr');
	for (var i=0; i < trs.length; i++) {
		trs[i].addEventListener('click', _abpersonclick, false);
	};
	
	document.getElementById("search").addEventListener('keyup', ABSearch, false);
}

function ABSearch (e) {
	var table = document.getElementById('people').getElementsByTagName('table')[0];
	var trs = table.getElementsByTagName('tr');
	var searchStr = document.getElementById('search').value.toLowerCase();
	for (var i=0; i < trs.length; i++) {
		var text = trs[i].firstChild.firstChild.data.toLowerCase();
		if (text.indexOf(searchStr) >= 0) trs[i].style.display = '';
		else trs[i].style.display = "none";
	};
	table.stripe();
}

function _abgroupclick(e) {
	var name = this.firstChild.innerHTML;
	request = new AsyncRequest();
	request.action = function(a, req) { _groupReceived(a, req, name); }
	request.fetch('/ab/fetch/group/' + name);
	// request = new XMLHttpRequest();
	// request.onload = function(a) { _groupReceived(a, request, name); }
	// request.open("GET", "/ab/fetch/group/" + name);
	// request.send(null);
	
	var t = document.getElementById('groups').getElementsByTagName('table')[0];
	var trs = t.getElementsByTagName('tr');
	for (var i=0; i < trs.length; i++) {
		trs[i].className = '';
		trs[i].style.background = '';
	};
	this.className = 'selected';
	t.stripe();
}

function _groupReceived (e, request, name) {
	var arr = eval(request.request.responseText);
	var d = document.getElementById('people');
	var t = d.getElementsByTagName('table')[0];
	
	while (t.firstChild) 
	{
		t.firstChild.removeEventListener('click', _abpersonclick, false);
		t.removeChild(t.firstChild); // Clear out old people
	}
		
	for (var i=0; i < arr.length; i++) {
		tr = document.createElement("tr");
		td = document.createElement("td");
		txt = document.createTextNode(arr[i]);
		t.appendChild(tr);
		tr.appendChild(td);
		td.appendChild(txt);
		tr.addEventListener('click', _abpersonclick, false);
	}
	t.stripe();
}

function _abpersonclick(e) {
	var name = this.firstChild.innerHTML;
	request = new AsyncRequest();
	request.action = function(a, req) { _personReceived(a, req, name); };
	request.fetch('/ab/fetch/person/' + escape(name));
	// request = new XMLHttpRequest();
	// request.onload = function(a) { _personReceived(a, request, name); }
	// request.open("GET", "/ab/fetch/person/" + escape(name));
	// request.send(null);
	
	var t = document.getElementById('people').getElementsByTagName('table')[0]
	var trs = t.getElementsByTagName('tr');
	for (var i=0; i < trs.length; i++) {
		trs[i].className = '';
		trs[i].style.background = '';
	};
	this.className = 'selected';
	t.stripe();
}

function _personReceived (e, request, person_name) {
	var dict = eval('('+request.request.responseText+')');
	var d = document.getElementById('person');
	
	while (d.firstChild) d.removeChild(d.firstChild);
	var name = dict['name'];

	// Add image
	var div = document.createElement("div");
	d.appendChild(div);
	div.id = 'image';
	var img = document.createElement("img");
	img.src = "/ab/img/" + name;
	div.appendChild(img);
	
	// Add name
	var h1 = document.createElement("h1");
	h1.appendChild(document.createTextNode(name));
	d.appendChild(h1);
	
	// Add job title and organization
	var jobtitle = dict['JobTitle'];
	var department = dict['ABDepartment'];
	if (jobtitle || department)
	{
		var h4 = document.createElement("h4");
		var txt = '';
		if (jobtitle && department) txt = jobtitle + ' - ' + department;
		else if (jobtitle) txt = jobtitle;
		else if (department) txt = department;
		h4.appendChild(document.createTextNode(txt));
		d.appendChild(h4);
	}
	
	// Add organization
	if (dict['Organization'] && name != dict['Organization'])
	{
		var h4 = document.createElement("h4");
		h4.appendChild(document.createTextNode(dict['Organization']));
		d.appendChild(h4);
	}
	
	// Phone numbers, emails, urls, and aims
	var bl = ABCreateInfoBlockFromArray(dict['Phone']);
	if (bl) d.appendChild(bl);
	bl = ABCreateInfoBlockFromArray(dict['Email']);
	if (bl) d.appendChild(bl);
	bl = ABCreateInfoBlockFromArray(dict['URLs']);
	if (bl) d.appendChild(bl);
	bl = ABCreateInfoBlockFromArray(dict['AIMInstant']);
	if (bl) d.appendChild(bl);
	
	// Add Birthday
	if (dict['Birthday'])
	{
		var p = document.createElement("p");
		p.className = 'abvalue';
		var span = document.createElement("span");
	 	p.appendChild(span);
		span.appendChild(document.createTextNode("birthday"));
	 	p.appendChild(document.createTextNode(' ' + dict['Birthday']));
		d.appendChild(p);
	}
	
	// Add addresses
	var addrs = dict['Address'];
	if (addrs) {
		for (var i=0; i < addrs.length; i++) {
			var addr = addrs[i]['value'];
			
			var p = document.createElement("p");
			p.className = 'abvalue';
			d.appendChild(p);

			var span = document.createElement("span");
			span.appendChild(document.createTextNode(addrs[i]['label']));
			p.appendChild(span);
			
			var pre = document.createElement("pre");
			var street = addr['Street'];
			var city = addr['City'];
			var state = addr['State'];
			var zip = addr['ZIP'];
			var country = addr['Country'];
			var address = '';
			if (street) address += street + "\n";
			if (city) address += city + " ";
			if (state) address += state + " ";
			if (zip) address += zip + " ";
			if (country) address += country;
			
			pre.appendChild(document.createTextNode(address));
			p.appendChild(pre);
		};
	}
	
	// =========================
	// = Todo: Notes =
	// =========================
	
}

function ABCreateInfoBlockFromArray (arr) {
	if (arr == null || arr.length == 0) return null;
	var bl = document.createElement("div");
	bl.className = "abblock";
	for (var i=0; i < arr.length; i++) {
		var p = document.createElement("p");
		p.className = "abvalue";
		var span = document.createElement("span");
		span.appendChild(document.createTextNode(arr[i]['label']));
		p.appendChild(span);
		p.appendChild(document.createTextNode(' '+arr[i]['value']));
		bl.appendChild(p);
	};
	return bl;
}

window.addEventListener('load', _abinit, false);